v2.4.5 2026-08-10  Aki Tuomi <aki.tuomi@open-xchange.com>

	* CVE-2026-27852: Messages with a huge number of From/To/Cc/etc email addresses
	  could result in excessive memory usage.
	* CVE-2026-33263: Submission: Login service crashes with panic once
	  mail_max_userip_connections limit is reached.
	* CVE-2026-33604: The SMTP outbound dot-stuffing mechanism does not properly
	  escape dots following a bare \r in message bodies, potentially allowing
	  spoofed emails via malicious end-of-DATA injection.
	* CVE-2026-33606: Mail content stored by a user can be crafted so that it is
	  interpreted as dsync protocol commands when an administrator later runs dsync
	  with the stream protocol, for example during a migration.
	* CVE-2026-33607: IMAP LIST command could be used to cause excessive CPU usage.
	* CVE-2026-40014: IMAP THREAD command could have used excessive amount of CPU
	  processing a single email with a massive number of Message-IDs in References
	  header.
	* CVE-2026-40015: Invalid IMAP command sent to imap-hibernate process might
	  crash it.
	* CVE-2026-40017: IMAP THREAD command could have used excessive amount of CPU
	  processing emails with a large number of specially crafted Message-IDs in
	  References header. The fix requires a new dovecot.index.thread file format,
	  which is enabled only after setting dovecot_storage_version or newer. This
	  rebuilds the index, so it will cause some extra CPU usage and extra
	  metacache disk IO usage. It shouldn't cause (much) extra object storage IO,
	  because all the fields should be coming from dovecot.index.cache.
	* CVE-2026-40203: When IMAP COMPRESS=DEFLATE was enabled, an attacker
	  could send mails into a victim's mailbox and observe network traffic to
	  determine whether a secret message matched a known string by comparing
	  compressed response sizes (a CRIME-style attack). The fix resets the
	  compression dictionary after each IMAP command, preventing information from
	  leaking between commands.
	* CVE-2026-40205: If multiple OAUTH scopes were required, then
	  this could have been only partially enforced with certain
	  configurations.
	* CVE-2026-4200: XCLIENT FORWARD allows to forward key only passdb
	  fields without the "forward_" prefix which allows connections from
	  trusted networks to set nopasswd field which allows to skip the
	  authentication.
	* CVE-2026-42391: Pre-login IMAP ID command could have used excessive
	  amount of memory, causing the process to become killed and disconnecting
	  all the other IMAP connections being proxied by the process. Or
	  alternatively it could have caused excessive CPU usage, slowing down
	  all the other IMAP connections being proxied by the process.
	* CVE-2026-42392: If URLAUTH is enabled, sending an invalid IMAP URLFETCH
	  can result in an untagged NO response containing uninitialized memory,
	  potentially leaking sensitive data.
	* CVE-2026-42393: Doveadm password length or API key length could still
	  be determined via timing based attacks.
	* CVE-2026-42395: XCLIENT FORWARD command from login_trusted_networks
	  could have been used to cause login processes to crash.
	* CVE-2026-52681: Sieve resource usage (sieve_max_cpu_time) was tracked
	  in the active Sieve binary. Switching to a different active binary
	  could have been used to reset (bypass) the resource usage.
	* CVE-2026-52687: Using IMAP COMPRESS ZSTD command can cause excessive
	  memory usage in imap-login process, possibly making it reach vsz_limit
	  and kill all the connections being served by the process. Fixed by
	  disabling COMPRESS command with all other compression algorithms than
	  the standard DEFLATE.
	* CVE-2026-73208: In oauth2, scope/aud checking was done with JWT tokens.
	  Now it requires all scopes.
	* CVE-2026-73209: Sending IMAP COMPRESS package containing zero-length
	  frames crashes imap or imap-login process.
	* auth: SIGHUP no longer flushes the passdb cache and SIGUSR2 no longer
	  logs cache statistics. Use "doveadm auth cache flush" and the new
	  "doveadm auth cache status" instead.
	* auth: The OTP authentication mechanism, the {OTP} password scheme and
	  the passdb set-credentials support have been removed. They were
	  unmaintained and unused. This also drops the passdb_sql_update_query
	  setting.
	* config: doveconf no longer prints a flat global setting when a
	  top-level named filter overrides the same setting.
	* doveadm: The doveadm protocol has been bumped to v1.4. The server uses
	  the newer multiplex stream format with clients supporting it. Older
	  clients keep working unchanged.
	* imap: Change imap_compress_on_proxy default to yes.
	* lib-dict-extra: Increase dict client request timeout from 30s to 65s,
	  so it stays above the SQL/Cassandra query timeout.
	* lib-http: HTTP requests are now parsed strictly: obsolete line folding
	  (obs-fold) and a bare LF line terminator are rejected. Both are
	  request desynchronization/smuggling risks. HTTP responses are still
	  parsed leniently.
	* lib-storage: A '~' in a mailbox name is now escaped only when it is at
	  the beginning of the mailbox name, not at the beginning of every
	  hierarchy part. Directories written by older versions are migrated
	  automatically while listing mailboxes.
	* lib-var-expand: Add %{time:unix} provider and the epoch, from_epoch,
	  date, iso8601 and escape filters. Deprecates the old time providers.
	* lib-var-expand: The safe filter must now be the last filter in the
	  chain.
	* master: Increase the timeout after config reload before killing still
	  running old processes from 6s to 35s, so that lib-master can stop them
	  gracefully first.
	+ config: Support heredoc syntax for multi-line setting values:
	  key = <<EOD ... EOD. doveconf now outputs inline SET_FILE contents
	  (e.g. ssl_ca) using heredoc instead of the "inline:" prefix. The
	  "inline:" form is still accepted.
	+ configure: Build imap-hibernate also when only kqueue notify is
	  available.
	+ doveadm: Add "doveadm auth cache status" command, with --reset for
	  clearing the counters.
	+ doveadm: dump - List all supported dump types, and print the key type
	  also for KEM and unsupported keys.
	+ fts-flatcurve: Add support for phrase searching. This fixes false
	  positives where the searched words existed, but not as a phrase.
	+ fts-flatcurve: Delete the FTS index directory also when a Maildir
	  mailbox is deleted.
	+ imap: Add [THROTTLED] response code to tagged replies when a plugin
	  has throttled the command.
	+ last-login: Add last_login_dict_fields setting for updating multiple
	  dictionary fields at login.
	+ lib-dcrypt: Add ML-KEM-512/768/1024 support with OpenSSL 3.
	+ lib-dcrypt: Support AEAD with Dovecot key encryption.
	+ lib-settings: Expand %{variables} also in strlist and boollist keys.
	+ lib-sql: sqlite - Add sqlite_busy_timeout setting, default 1s.
	+ login-common: Log the destination also when a proxy connection fails.
	+ quota: Update quota-clone also when "doveadm quota recalc" is run.
	- Fix building on systems with a signed 32-bit time_t.
	- Fix building with Lua when LUA_LIBS contains linker flags such as -L.
	- anvil: Fix busy loop eating CPU after an admin socket connection was
	  disconnected.
	- auth: Fix authentication failing after a password change when the
	  passdb cache entry was verified by an auth worker.
	- auth: Fix the credentials scheme of one passdb leaking into the next
	  one during a multi-passdb lookup.
	- auth: oauth2 - Fix losing userdb_* fields during OAUTHBEARER
	  authentication.
	- auth: passwd-file - Fix %{passdb:...} and %{userdb:...} expansion
	  returning garbage or crashing.
	- config: Fix crash in "doveconf -f" for a filter that includes a @group.
	- config: Fix crash when including a default @group into a filter.
	- config: Fix hiding secrets in doveconf output.
	- config: Fix startup failures with some settings containing %{variables}.
	- configure: Fix BUILD_IMAP_HIBERNATE detection.
	- doc: solr-schema-9.xml - Add the mandatory tokenizer class attribute.
	- doveadm: compress-connect - Fix writing server input to a non-blocking
	  stdout.
	- doveadm: fs delete - Fix crash with concurrent async deletes.
	- doveconf: Fix bogus "Multiple settings matched" error when stdout is
	  redirected to a file that already has content.
	- dsync: Fix truncating a mailbox attribute value when it is compared to
	  the local one, e.g. truncating a Sieve script.
	- dsync: backup - Mailbox attributes changed or created only in the
	  destination are now reverted or deleted.
	- fts-flatcurve: Ignore index directory entries that vanish during
	  iteration.
	- fts: Don't run FTS optimize on forced resync.
	- fts: build-mail - Fix accessing Content-Type header buffer out of
	  bounds.
	- imap-login, pop3-login: Tolerate SASL continuations "+" without a
	  trailing space when proxying authentication.
	- imap: Don't report FETCH output stream errors as
	  "BUG: Unknown internal error".
	- imap: Fix hibernation always failing on FreeBSD.
	- imap: Fix panic on GETMETADATA with an invalid UTF-8 mailbox pattern.
	- imapc: Don't send SEEEN/UNSEEN to the remote server when private
	  indexes are used.
	- imapc: Fix SEARCH results pointing at wrong messages after an untagged
	  EXPUNGE.
	- imapc: Fix SORT returning an empty result when search criteria were
	  used.
	- imapc: Fix crash when copying a mail that was already expunged in the
	  source mailbox.
	- imapc: Fix stale SEARCH/SORT results after a STORE in the same
	  session.
	- imapc: Honor imapc_features=no-search also for SORT.
	- imapc: Properly handle search criteria that can be sent to remote server.
	- lib-dcrypt: Don't panic on key algorithms the backend doesn't support.
	- lib-dcrypt: Fix x9.62 ECDSA signatures randomly failing verification.
	- lib-dict-backend: cdb - Fix use-after-free of the returned key.
	- lib-dns-client: Fix handling of a disconnect initiated by the
	  dns-client service.
	- lib-fs: Fix panic in fs_write_stream_abort(), e.g. when the disk is
	  full during FTS indexing.
	- lib-index: Fix "File is already open" error when appending to the
	  transaction log while another process is rotating it. This showed up
	  as "NO [SERVERBUG] Internal error occurred." without any logging.
	- lib-ldap: Fall back to system default CA paths, needed for OpenLDAP
	  built against GnuTLS.
	- lib-mail: istream-binary-converter - Fix heap use-after-free with a
	  bodyless MIME part.
	- lib-mail: message-parser - Fix out of bounds read with an empty
	  preamble, fix skipping the epilogue boundary line, and degrade to a
	  re-parse instead of panicking with an inconsistent cached MIME tree.
	- lib-master: Fix kick reason when the KICK-USER-SIGNAL command arrives
	  late, which logged "Killed with signal 15" instead of "User kicked".
	- lib-oauth2: jwt - Fix use-after-realloc, guard against an empty body
	  segment and percent-encode bare "." and ".." identifiers.
	- lib-program-client: Fix panic upon irregular termination.
	- lib-settings: Fix sorting of the settings history, which caused
	  changed defaults and renames to be ignored once a plugin registered
	  its own history, if dovecot_config_version has been set to greater
	  than 2.4.0.
	- lib-smtp: Fix assert with an empty broken localpart.
	- lib-smtp: xclient - Reject an invalid HELO parameter with 501.
	- lib-sql: pgsql - Fix binary field values for rows after the first.
	  This mainly affected dict-sql maps with hexblob fields.
	- lib-ssl-iostream: Fix crash at process exit with OpenSSL 4.0.
	- lib-storage: Don't log an error when the client resets the connection
	  while saving a mail.
	- lib-storage: Fix crash when reverting a failed mailbox deletion.
	- lib-storage: Fix decoded size calculation for base64 attachments,
	  which could delete the cache record of a mail with a detached
	  attachment.
	- lib-storage: Fix handling escaped mailbox names in the mailbox list
	  index.
	- lib-storage: Fix rewriting non-NFC subscriptions with mUTF-7 storage
	  names, which caused repeated rename errors.
	- lib-storage: Fix searching flags when the view is not up to date. This
	  broke e.g. a pipelined UID STORE +FLAGS \Deleted followed by UID
	  EXPUNGE.
	- lib-storage: Fix the mailbox vsize header not being repaired when it
	  is corrupted, causing wrong mailbox sizes to be reported.
	- lib-storage: thread - Fix panic when running IMAP THREAD in multiple
	  connections in parallel.
	- lib-var-expand: Reject an empty separator in the index filter, which
	  caused an infinite loop.
	- lib: Fix crash and out of bounds reads when decoding IDN addresses.
	  Reachable only with the experimental mail UTF-8 support enabled.
	- lib: ioloop - Fix panic and delayed timeouts when time moves forwards.
	- lib: ostream-multiplex - Fix stalls, busy loops and a panic when
	  streaming data through a multiplexed connection, e.g. IMAP FETCH
	  through a login proxy or TLS connections.
	- login-common: Fix connection hanging if an ostream write failed. This
	  happened at least with HAProxy health check connections.
	- login-common: Fix real_remote_ip being looked up incorrectly.
	- login-common: Reject proxy credentials with ASCII control characters.
	- login-proxy: Fix "doveadm kick" for proxied connections in
	  high-security mode, and log "Kicked by admin" as the reason.
	- maildir: Fix random SEARCH failures when another session concurrently
	  expunges mails.
	- quota: Fix maildir quota dropping to zero after IMAP MOVE or REPLACE.
	- submission-login: proxy - Fix crash and unbounded memory usage with a
	  multi-line or malformed AUTH reply from the backend.

v2.4.4 2026-05-06  Aki Tuomi <aki.tuomi@open-xchange.com>

	* CVE-2026-27851: lib-var-expand: Safe filter marks all following pipelines safe.
	* CVE-2026-33603: auth: CRAM-SHA-*-PLUS channel binding could be faked.
	  MITM attacker with a certificate trusted by the client could have
	  bypassed the requirement for channel binding.
	* CVE-2026-40020: IMAP folders can be shared-spammed to everyone.
	* CVE-2026-42006: An attacker can cause uncontrolled memory usage with
	  excessive bracing over IMAP. The fix in CVE-2026-27857 was incomplete.
	* indexer-worker, quota-status, script-login, program-client-local: Root
	  privileges are now dropped permanently before serving requests.
	* indexer-worker: Default restart_request_count changed to 1 to work
	  correctly after permanent root privilege drop.
	* lmtp: Add back service_extra_groups=$SET:default_internal_group that was
	  incorrectly removed in v2.4.3.
	* master: inet_listener_reuse_port has been replaced by service_reuse_port.
	  The new setting properly pre-creates all listener sockets at startup and
	  assigns one unique socket per process. Using this allows evenly distributing
	  incoming connections to login processes. See
	  https://doc.dovecot.org/latest/core/config/service.html#service_reuse_port
	  for details.
	- auth: Fix LDAP escaping of 0x13 control character.
	- auth: Use timing-safe comparison for certificate and public key fingerprints.
	- fts: Correctly handle internal http-client response errors.
	- fts: Don't send request to Tika if there is no body text.
	- fts: Fix address header indexing for RFC 2047 encoded-words.
	- fts: tika, fts-solr: Fix use-after-free crash during DNS lookup.
	- imap: Fix assertion panic on invalid REPLACE 0 command.
	- lib-auth-client: Avoid "unknown id" errors for aborted auth requests.
	- lib-dcrypt: Fix potential crash if trying to access untrusted/corrupted keys.
	- lib-dcrypt: Improve error message if keys aren't in hex format as expected.
	- lib-index: Fix potential crash if fsck fails.
	- lib-ldap: Fix using OpenLDAP default CA when ssl_client_ca_dir/file is unset.
	  v2.4.3 regression.
	- lib-master, master: Fix behavior for services with client_limit>1 and
	  restart_request_count so that processes reaching restart_request_count are
	  no longer counted towards process_limit.
	- lib-master: Fix crash when reaching client_limit with restart_request_count>1.
	- lib-master: haproxy - Don't trust client certificate common name when
	  HAProxy reports verification failure.
	- lib-sasl: cram-md5 - Fix out of bounds memory read.
	- lib-sasl: oauth2 - Fix one byte out of bounds read.
	- lib-sql: cassandra - Fix reusing Cassandra SSL connections.
	- lib-sql: sqlite - Fix sqlite_journal_mode=wal to actually work.
	- lib-storage: Auto-rename non-NFC subscription file entries to NFC on read.
	- lib-storage: Prevent non-atom SEARCH keywords from causing IMAP
	  command injection.
	- lib-var-expand-crypt: Return error if hex decoding fails.
	- lib-var-expand: Fix crash (SIGFPE) with non-positive divisor for / and %.
	- log: Fix memory leak at deinit.
	- login-common: When process is full, don't destroy clients waiting on
	  master auth.
	- login-proxy: Fix crash with rawlog and multiplexing during reconnection.
	- mail-compress: Fix panic when save method unavailable.
	- mail-crypt: Fix crash when HMAC-based algorithm is used.
	- mail-crypt: Use AEAD instead of HMAC with ChaCha20-Poly1305.
	- mdbox: Create files with O_NOFOLLOW.
	- push-notification: ox - Fix use-after-free crash during DNS lookup.
	- quota: quota-status - Limit input buffer size to 1 kB.

v2.4.3 2026-03-27  Aki Tuomi <aki.tuomi@open-xchange.com>

	* CVE-2025-59028: Invalid base64 authentication can cause DoS for other
	  logins.
	* CVE-2025-59031: decode2text.sh OOXML extraction may follow symlinks
	  and read unintended files during indexing. Fixed by dropping the script.
	* CVE-2026-24031: SQL injection possible if auth_username_chars is
	  configured empty. Fixed escaping to always happen. v2.4 regression.
	* CVE-2026-27859: Excessive RFC 2231 MIME parameters in email would cause
	  excessive CPU usage. Fixed by limiting number of parameters to process.
	* CVE-2026-27860: LDAP query injection possible if auth_username_chars
	  is configured empty. Fixed escaping to always happen. v2.4 regression.
	* CVE-2026-27857: Sending excessive parenthesis causes imap-login to use
	  excessive memory.
	* CVE-2026-27856: Doveadm credentials were not checked using timing-safe
	  checking function.
	* CVE-2026-27855: OTP driver vulnerable to replay attack.
	* Remove default service/*/service_extra_groups=$SET:default_internal_group.
	  They are now replaced by default mail_access_groups=$SET:default_internal_group.
	* The version file has been renamed as version.txt to avoid clash with
	  C++ headers.
	* auth: oauth2 - Do not export token automatically, must be exported using
	  fields.
	* config: Don't accept 0 as meaning unlimited anymore for
	  last_valid_uid, last_valid_gid, mail_cache_max_headers_count,
	  mail_cache_max_header_name_length, mail_vsize_bg_after_count,
	  mail_sort_max_read_count, message_max_size, submission_max_recipients
	  and quota_mail_size.
	* imap, pop3: Don't autoexpunge if Dovecot is shutting down or process
	  is killed.
	* imap: LIST - Handle invalid mUTF-7 mailbox names as never matching anything
	* lazy-expunge: Change lazy_expunge_only_last_instance default to yes.
	* lda: Use EX_TEMPFAIL (75) if configuration is invalid instead of 89.
	  v2.4 regression.
	* lib-master: Increase ANVIL_DEFAULT_LOOKUP_TIMEOUT_MSECS from 5s to 30s
	* lib: crc32 - Use zlib's built-in CRC32 function
	+ Improve UTF-8 support for mail storage.
	+ auth: Add default auth-token UNIX socket for token-based authentication.
	+ doc: solr-config-9.xml - Make it compatible with Solr 9.8.0
	+ doveadm: dsync - Search mails when exporting to reduce number of mails
	  exported by dsync-server.
	+ dovecot-sysreport: Add -D|--destdir support.
	+ imap, imap-hibernate: Use DOVECOT-TOKEN authentication for unhibernation.
	  Default imap-master socket permissioms have been changed due to this.
	+ imap: Add APPENDLIMIT capability when configured with quota_mail_size.
	+ imap: Support STATUS (DELETED) for IMAP4rev2.
	+ imapc: Add support for SEARCH MIMEPART
	+ imapc: Improve error forwarding.
	+ imapc: Support SORT and ESORT extensions.
	+ imapc: Support STATUS (DELETED) for IMAP4rev2.
	+ lib-sql: Support parameterized queries.
	+ lib-test: Add new test-dir API for better temporary test directory
	  handling.
	+ lmtp: Advertize SIZE capability when configured with quota_mail_size.
	+ lmtp: Support XCLIENT DESTADDR and DESTPORT
	+ pop3-login: proxy - Add support for XCLIENT DESTIP and DESTPORT
	+ submission-login: proxy - Add support for XCLIENT DESTIP and DESTPORT
	+ Various optimizations have been made to the code.
	- Fix building dovecot with BSD, Solaris and macOS.
	- auth: Crash would occur if users were iterated but
	  userdb_ldap_iterate_fields was not set.
	- auth: Fix request leak when client authenticates with unsupported mechanism.
	- auth: Some passdbs would default to PLAIN instead of CRYPT scheme.
	- config: Section and setting names could have been intermixed, resulting
	  in the setting being silently ignored.
	- configure: Fix checking if BUILD_IMAP_HIBERNATE is set
	- doveadm: dsync - -e parameter was handled wrong with dsync-server.
	- fts-flatcurve: Mailbox leak would occur if mailbox failed to open.
	- imap: Fix potential issues with unhibernation and process state handling.
	- imapc: SEARCH failure handling was done wrong.
	- imapc: UID STORE commands included extra comma in uidset.
	- lib-auth-client: auth-master - Fix panic when reconnecting after
	  handshake timeout.
	- lib-compression: Lz4 algorithm would assert-crash with malicious data.
	- lib-dcrypt: Fix digest algorithm handling.
	- lib-dict: Escape username paths to prevent traversal issues with dict-fs.
	- lib-http: Fix HTTP parsing edge cases and state handling.
	- lib-iostream: Disallow empty ssl_min_protocol.
	- lib-json: Fix incorrect character handling logic.
	- lib-ldap: Fix various TLS related bugs.
	- lib-mail: Fix charset translation and MIME parsing edge cases.
	- lib-mail: Fix multiple bounds checks and parsing issues in message handling.
	- lib-var-expand: Multiple fixes and improvements for expansion handling.
	- lib: Fix punycode decoding out-of-bounds reads.
	- lib: Fix unicode normalization edge cases causing crashes.
	- lib-http: Chunked transfer trailer size was not limited.
	- login-common: Improve logging and internal error handling.
	- login-common: login_log_format_elements was split by spaces naively, which
	  could break variable expansion. Use template aware splitting now.
	- master: Dovecot would fail to start if listen directive was used and
	  dovenull or dovecot user was missing.
	- pop3c: Connection might've hung with SSL.
	- util: Fix handling of environment variables containing control characters.
	- Many other bugs have been fixed.

v2.4.2 2025-10-24  Aki Tuomi <aki.tuomi@open-xchange.com>

	* CVE-2025-30189: Passdb oauth2 (not oauth2 mechanism), passdb passwd,
	  passdb bsdauth, and userdb passwd drivers would cause users to be
	  cached with same cache key when auth cache was enabled.
	* auth: Remove proxy_always field.
	* config: Change settings history parsing to use python3.
	* doveadm: Print table formatter - Print empty values as "-".
	* imapc: Propagate remote error codes properly.
	* lda: Default mail_home=$HOME environment if not using userdb lookup
	* lib-dcrypt: Salt for new version 2 keys has been increased to 16 bytes.
	* lib-dregex: Add libpcre2 based regular expression support to Dovecot,
	  if the library is missing, disable all regular expressions. This
	  adds libpcre2-32 as build dependency.
	* lib-oauth2: jwt - Allow nbf and iat to point 1 second into future.
	* lib: Replace libicu with our own unicode library. Removes libicu as build
	  dependency.
	* login-common: If proxying fails due to remote having invalid SSL cert, don't reconnect.
	+ auth: Add ssl_client_cert_fp and ssl_client_cert_pubkey_fp fields, see
	  https://doc.dovecot.org/latest/core/summaries/settings.html#ssl_peer_certificate_fingerprint_hash
	  for more information.
	+ config: Add support for $SET:filter/path/setting.
	+ config: Improve @group includes to work with overwriting their settings.
	+ doveadm kick: Add support for kicking multiple usernames
	+ doveadm mailbox status: Add support for deleted status item.
	+ imap, imap-client: Add experimental partial IMAP4rev2 support.
	+ imap: Implement support for UTF8=ACCEPT for APPEND
	+ lib-oauth2, oauth2: Add oauth2_token_expire_grace setting.
	+ lmtp: lmtp-client - Support command pipelining.
	+ login-common: Support local/remote blocks better.
	+ master: accept() unix/inet connections before creating child process
	  to handle it. This reduces timeouts when child processes are slow to
	  spawn themselves.
	- SMTPUTF8 was accepted even when it wasn't enabled.
	- auth, *-login: Direct logging with -L parameter was not working.
	- auth: Crash occured when OAUTH token validation failed with
	  oauth2_use_worker_with_mech=yes.
	- auth: Invalid field handling crashes were fixed.
	- auth: ldap - Potential crash could happen at deinit.
	- auth: mech-gssapi - Server sending empty initial response would cause
	  errors.
	- auth: mech-winbind - GSS-SPNEGO mechanism was erroneously marked as
	  not accepting NUL.
	- config: Multiple issues with $SET handling has been fixed.
	- configure: Building without LDAP didn't work.
	- doveadm: If source user didn't exist, a crash would occur.
	- imap, pop3, submission, imap-urlauth: USER environment usage was broken
	  when running standalone.
	- imap-hibernate: Statistics would get truncated on unhibernation.
	- imap: "SEARCH MIMEPART FILENAME ENDS" command could have accessed
          memory outside allocated buffer, resulting in a crash.
	- imapc: Fetching partial headers would cause other cached headers to
	  be cached empty, breaking e.g. imap envelope responses when caching to disk.
	- imapc: Shared namespace's INBOX mailbox was not always uppercased.
	- imapc: imapc_features=guid-forced GUID generation was not working correctly.
	- lda: USER environment was not accepted if -d hasn't been specified.
	- lib-http: http-url - Significant path percent encoding through parse
	  and create was not preserved. This is mainly important for Dovecot's
	  Lua bindings for lib-http.
	- lib-settings: Crash would occur when using %variables in SET_FILE type settings.
	- lib-storage: Attachment flags were attempted to be added for
	  readonly mailboxes with mail_attachment_flags=add-flags.
	- lib-storage: Root directory for unusable shared namespaces was
	  unnecessarily attempted to be created.
	- lib: Crash would occur when config was reloaded and logging to syslog.
	- login-common: Crash might have occured when login proxy was destroyed.
	- sqlite: The sqlite_journal_mode=wal setting didn't actually do anything.
	- Many other bugs have been fixed.

v2.4.1 2025-03-28  Aki Tuomi <aki.tuomi@open-xchange.com>

	* auth: Change unix_listener/auth-userdb/group = $SET:default_internal_group
	  This change needs dovecot_config_version=2.4.1.
	* auth: lua - Remove support for single string result.
	* imap: Unconditionally advertise SPECIAL-USE capability.
	* lib-dcrypt: Install dcrypt_openssl.so into dovecot modules directory.
	* lib-master: For glibc, default MALLOC_MMAP_THRESHOLD_=131072.
	* lib-storage: Change default mail_cache_fields to:
	  hdr.date hdr.subject hdr.from hdr.sender hdr.reply-to hdr.to
	  hdr.cc hdr.bcc hdr.in-reply-to hdr.message-id
	  date.received size.virtual imap.bodystructure mime.parts hdr.references
	  hdr.importance hdr.x-priority hdr.x-open-xchange-share-url
	  pop3.uidl pop3.order. This change needs dovecot_config_version=2.4.1.
	* lib-var-expand: Use moduledir instead of pkglibdir for crypt.
	* lmtp: Change the default lmtp_user_concurrency_limit to 10.
	  This change needs dovecot_config_version=2.4.1.
	* lmtp: Change the default service_restart_request_count to 1.
	  This change needs dovecot_config_version=2.4.1.
	+ auth: Allow configuring passdb/userdb sql to use auth-workers.
	+ config: Add default group @mailbox_defaults = english.
	+ config: Improve "Unknown setting" error with more details and
	  suggestions.
	+ doveconf: Add -U parameter to ignore unknown settings in config file.
	+ fts-flatcurve: Support lock files in VOLATILEDIR.
	+ imap-acl: Add support for the IMAP LIST-MYRIGHTS capability (RFC 8440).
	+ imap-client: Support ANONYMOUS authentication.
	+ imap: Implement support for the REPLACE capability.
	- auth: ldap - Passdb fields were ignored with
	  passdb_ldap_bind_userdn=yes.
	- auth: lua - Fix error result handling in lua passdb/userdb.
	- auth: oauth2 - When building oauth2 failure reply, memory would leak.
	- config: local_name handling would work wrong with multiple names and
	  wildcards.
	- fts-flatcurve: A potential crash could occur when searching virtual
	  mailboxes.
	  Fixes: Panic: file fts-search.c: line 87 (level_scores_add_vuids):
	  assertion failed: (array_count(&vuids_arr) == array_count(&br->scores))
	- fts-flatcurve: Maybe queries were done wrong.
	- fts-flatcurve: Non-selectable mailboxes were not ignored when doing
	  optimize/rescan.
	- fts-flatcurve: Signal 11 crash could happen with fts rescan.
	- fts: Fix crash caused by event object lifecycle mishandling.
	- imap-hibernate: Client counters would get reset on unhibernation,
	  affecting imap_logout_format variables.
	- imap: Crash would occur with Maildir when trying to send INPROGRESS
	  during mailbox syncing.
	- ldap: Dovecot could not be compiled without LDAP.
	- lib-dcrypt: Output stream encryption can cause assert crash if
	  attempting to encrypt over 64 GiB of data with GCM. This is still not
	  supported with GCM, but it fails better.
	- lib-http: HTTP client context memory usage was increasing.
	- lib-http: Pipeline corruption could happen after 100 Continue response.
	- lib-settings: Variable expansion initialization could crash with
	  Panic: file settings.c: line 1560 (settings_var_expand_init_add):
	  assertion failed: (I_MAX(num_tables, num_provs) == num_ctx)
	- lib-smtp: Pipelining initial SASL response after AUTH was broken.
	- lib-var-expand: If filter failed, memory leak would occur.
	- lib-var-expand: Older bison versions did not have error symbol for
	  handling causing unexpected behaviour on the parser on error conditions.
	- quota: Quota calculations had minor bugs causing small errors.

v2.4.0 2025-01-24  Aki Tuomi <aki.tuomi@open-xchange.com>

	* config: dovecot_config_version must be the first non-comment
	  line in configuration file.
	* config: dovecot_storage_version must be in the configuration
	  file.
	* config: Many configuration options have changed so old configuration
	  files do not work without rewrite. See
	  https://doc.dovecot.org/main/installation/upgrade/2.3-to-2.4.html
	* config: New variable expansion syntax has been introduced, see
	  https://doc.dovecot.org/main/core/settings/variables.html
	* config: Some default settings have changed.
	* config: plugin {} section has been removed.
	* *-login: With ssl=required, connections from login_trusted_networks
	  are now also required to be SSL/TLS encrypted.
	* acl: Use ACL settings instead of Global ACL Directories.
	* auth-worker: auth_worker_max_count is replaced with
	  service auth-worker { process_limit }.
	* auth: Weak password schemes are disabled by default, use
	  auth_allow_weak_schemes to enable them.
	* auth_debug, mail_debug: Use log_debug filter instead.
	* config: All sections require a name, for example passdb/userdb:
	  passdb static {
	     password=secret
	   }
	* db2: Remove Berkeley DB support.
	* dict-memcached: This is removed, use Redis instead.
	* director: Feature has been removed. See potential replacement at
	  https://github.com/dovecot/tools/blob/main/director.lua
	* doveadm: USER environment variable is only supported with
	  --no-userdb-lookup. One of -u, -F or -A must be used
	  otherwise.
	* doveconf: Option -n is now default when running doveconf.
	* dsync: Use doveadm sync instead, legacy symlink has been removed.
	* fs-sis: Feature is now deprecated and has been made read-only.
	  It will be removed in future release.
	* fts-lucene, fts-squat: These have been removed, use fts-flatcurve or
	  fts-solr instead.
	* imap-login: IMAP compression is now handled in proxies.
	* imap_quota: SETQUOTA / quota_set has been removed.
	* imap_zlib: This plugin is no longer needed, it's always enabled.
	* imapc: All features are enabled by default, imapc_features can be used
	  to explicitly disable features that are not wanted.
	* lib-storage: mbox driver is now frozen.
	* mail_compress: XZ and LZMA algorithm support has been removed.
	* mailbox-alias: Plugin has been removed.
	* old_stats, auth_stats: These have been removed.
	* openssl: Minimum supported version of OpenSSL is now 1.1.1.
	* openssl: Add support for OpenSSL 3.x
	* quota-dict, quota-dirsize: These have been removed, use quota-count
	  instead. You can use quota_clone to copy quota usage to some database.
	* replicator: Feature has been removed. Use NFS or some other shared
	  filesystem instead, or run doveadm sync in crontab.
	* stats: The bytes_in and bytes_out field in several events have been
	  renamed as net_in_bytes and net_out_bytes.
	* zlib: Renamed to mail_compress plugin.
	+ Experimental SMTPUTF8 and IMAP UTF8=ACCEPT support has been added.
	  Needs --enable-experimental-mail-utf8 configure option and
	  mail_utf8_extensions=yes setting.
	+ Long running mail commands can be aborted with Ctrl-C / doveadm kick.
	+ auth: LDAP driver now supports multi-value attributes.
	+ auth: Add support for SCRAM-SHA-1-PLUS and SCRAM-SHA-256-PLUS.
	+ auth: Add support for TLS channel binding.
	+ auth: Support sending JA3 hash to policy server.
	+ configure: Detect latest Lua version.
	+ *-login: Support for TLS Server Name has been improved to allow pre-login
	  settings. For example capabilities to be changed based on TLS Server Name.
	+ *-login: Support for TLS ALPN has been added, connections with mismatching
	  application are now refused. Missing ALPN is accepted.
	+ fts-flatcurve: New Xapian based FTS plugin has been added.
	+ imap: Support for INPROGRESS untagged messages as per RFC 9585.
	+ lib-lua: Expose Dovecot DNS client.
	+ lib-lua: Expose Dovecot HTTP client.
	+ lib-sasl: Support SCRAM-SHA mechanisms.
	+ lmtp: SNI support has been added which allows settings to be applied
	  based on TLS Server Name.
	+ sqlite: Support WAL mode.
	+ stats: Submetric name size has been increased.
	+ submission: Add submission_add_received_header setting to protect
	  sender identity by suppressing the Received: header.
	- Many bugs have been fixed.

v2.3.21.1 2024-08-14  Aki Tuomi< aki.tuomi@open-xchange.com>

	- CVE-2024-23184: A large number of address headers in email resulted
	  in excessive CPU usage.
	- CVE-2024-23185: Abnormally large email headers are now truncated or
	  discarded, with a limit of 10MB on a single header and 50MB for all
	  the headers of all the parts of an email.
	- oauth2: Dovecot would send client_id and client_secret as POST parameters
	  to introspection server. These need to be optionally in Basic auth
	  instead as required by OIDC specification.
	- oauth2: JWT key type check was too strict.
	- oauth2: JWT token audience was not validated against client_id as
	  required by OIDC specification.
	- oauth2: XOAUTH2 and OAUTHBEARER mechanisms were not giving out
	  protocol specific error message on all errors. This broke OIDC discovery.
	- oauth2: JWT aud validation was not performed if aud was missing
	  from token, but was configured on Dovecot.

v2.3.21 2023-09-15  Aki Tuomi <aki.tuomi@open-xchange.com>

	* lib-oauth2: Allow JWT tokens to be validated with missing typ field.
	  The typ field is left out by some key issuers to conserve space,
	  notably kubernetes. Now missing typ is tolerated, but if present, it
	  still must be "jwt".
	+ auth: Auth passdb and userdb reply can contain "event_<name>=value"
	  which will be added to login event and mail user event respectively.
	+ lib-master: Set process title during various initialization stages to
	  clearly describe what the process is waiting on.
	+ lib-storage: The mail_temp_scan_interval is now fuzzed incrementing it
	  by 0..30% based on username's hash to reduce the chance of load spikes.
	+ lib-storage: The temp file scan has been moved from the open of the
	  mailbox to the close, to reduce the latency perceived by users.
	+ stats: If metric has fields specified, all these fields are
	  exported as counters to prometheus exposition.
	  See https://doc.dovecot.org/configuration_manual/stats/openmetrics/.
	- *-login: Processes might have crashed when a SSL connection disconnects
	  uncleanly.
	- acl: When plugin was loaded \HasChildren and \HasNoChildren flags
	  were calculated incorrectly for mailboxes containing '*' and '%'
	  in their names.
	- auth: Crash occured if a connection to PostgreSQL database server
	  failed during startup.
	- auth: Logins with invalid passwords (e.g. unknown scheme) in passdb
	  were failing with "password mismatch" instead of "internal error".
	- auth: XOAUTH2 and OAUTHBEARER mechanisms were not giving out protocol
	  specific error message on all errors. This especially broke OIDC
	  discovery.
	- dbox: When last_temp_file_scan header wasn't set (especially after
	  dsync migration), the next mailbox open always triggers the temp file
	  scan. This could have caused a load spike after migrations. Fixed by
	  using the mailbox directory's atime when the header isn't set, which
	  usually moves the scan time into the future.
	- dict-redis: A crash would occur on transaction rollback.
	- dsync: Infinite loop causing out of memory would occur when handling
	  mailbox deletion from remote end and hierarchy separators would differ.
	- dsync: Incremental dsync failed for folder names ending with '%',
	  unless BROKENCHAR was set. Also folder names with '%' elsewhere in
	  them caused each incremental dsync to unnecessarily rename the folder
	  to a temporary name and back. v2.3.19 regression.
	- imap-hibernate: If an IMAP client unhibernation timed out with
	  "(version received)", the unhibernation could still have successfully
	  finished later on and continued working normally. This was rather
	  confusing, because imap-hibernate already logged that the client got
	  disconnected. Avoid this by forcing the connection to shutdown on
	  unhibernation timeout.
	- imapc: Crashed when a folder mapped through the virtual plugin
	  disappears from the storage.
	- imapc: EXPUNGE, EXISTS or FETCH replies from a server for a previously
	  selected mailbox could have been processed as if they belonged to the
	  new mailbox currently being selected. This could have caused warnings.
	- lib-http: Dovecot HTTP server (doveadm, stats/openmetrics) may have
	  disconnected HTTP clients before the response is fully sent. This
	  happened only on busy servers where kernel's socket buffers were
	  rather full.
	- lib-http: Fixed a potential crash on http-server if a client
	  disconnected early. v2.3.18 regression.
	- lib-index: Index file corruption could have caused a crash. Fixes:
	  Panic: file mail-transaction-log-view.c: line 165 (mail_transaction_log_view_set):
	  assertion failed: (min_file_seq <= max_file_seq).
	- lib-index: Purging an existing >1GB cache file can crash. Now cache
	  files still above 1GB after purging are removed. Fixes:
	  Panic: file mail-index-util.c: line 10 (mail_index_uint32_to_offset):
	  assertion failed: (offset < 0x40000000)
	- lib-lua: A HTTP client could not resolve DNS names in mail processes,
	  because it expected "the dns-client" socket to exist in the current
	  directory.
	- lib-oauth2: Dovecot would send client_id and client_secret as POST
	  parameters to the introspection server. These need to be optionally in
	  Basic auth instead.
	- lib-oauth2: JWT aud validation was not performed if aud was missing
	  from a token, but was configured on Dovecot.
	- lib-oauth2: JWT key type check was too strict.
	- lib-oauth2: JWT token audience was not validated against client_id as
	  required by the specification.
	- lib-ssl-iostream: Using the ssl_require_crl=yes setting may have caused
	  CRL check failures for outgoing SSL/TLS connections, although it was
	  supposed to affect checking CRLs only for client-side SSL
	  certificates. v2.3.17 regression.
	- lib-sql: MySQL driver leaked memory when connection failed.
	- lib-storage: Various fixes when running into out of disk space.
	- master: Service idle_kill setting didn't work properly on busy
	  servers. It was very unlikely that any process was idling long enough
	  to become killed. Also the idle_kill handling code was using quite a
	  lot of CPU on the master process when there were a lot of processes
	  (e.g. imap). The new behavior is to track the lowest number of idling
	  processes every idle_kill time interval and then kill that many idling
	  processes.
	- mdbox: Temp file scan was done for always empty directories.
	- mdbox: The fdatasync() call was done in wrong parent directory when
	  writing mails. Also on a failure it crashed instead of logging an error.
	- notify_status: The plugin crashes if any user initialization fails.
	- pop3: Sending command with the ':' character caused an assert-crash.
	  v2.3.18 regression. Fixes: Panic: event_reason_code_prefix(): name has ':'
	- stats: Fix panic when a nonexistent event exporter was referenced while
	  adding a new metric dynamically via doveadm stats add. This produces
	  a proper error now.
	- stats: If process exported a lot of events and then exited, some of
	  the last events may have become lost.
	- stats: Invalid Prometheus label names were created with specific
	  histogram group_by configurations. Prometheus rejected these labels.
	- welcome: The plugin didn't execute in some situations that created
	  INBOX but didn't open it, e.g. if GETMETADATA was used before the
	  INBOX was opened.

v2.3.20 2022-12-22  Aki Tuomi <aki.tuomi@open-xchange.com>

	+ Add dsync_features=no-header-hashes. When this setting is enabled and
	  one dsync side doesn't support mail GUIDs (i.e. imapc), there is no
	  fallback to using header hashes. Instead, dsync assumes that all mails
	  with identical IMAP UIDs contains the same mail contents. This can
	  significantly improve dsync performance with some IMAP servers that
	  don't support caching Date/Message-ID headers.
	+ lua: HTTP client has more settings now, see
	  https://doc.dovecot.org/admin_manual/lua/#dovecot.http.client
	+ replicator: "doveadm replicator status" command now outputs when the
	  next sync is expected for the user.
	- LAYOUT=index: duplicate GUIDs were not cleaned out. Also the list
	  recovery was not optimal.
	- auth: Assert crash would occur when iterating multiple userdb
	  backends.
	- director: Logging into director using master user with
	  auth_master_user_separator character redirected user to a wrong
	  backend, unless master_user_separator setting was also set to the same
	  value. Merged these into auth_master_user_separator.
	- dsync: Couldn't always fix folder GUID conflicts automatically with
	  Maildir format. This resulted in replication repeatedly failing
	  with "Remote lost mailbox GUID".
	- dsync: Failed to migrate INBOX when using namespace prefix=INBOX/,
	  resulting in "Remote lost mailbox GUID" errors.
	- dsync: INBOX was created too early with namespace prefix=INBOX/,
	  resulting a GUID conflict. This may have been resolved automatically,
	  but not always.
	- dsync: v2.3.18 regression: Wrong imapc password with dsync caused
	  Panic: file lib-event.c: line 506 (event_pop_global):
	  assertion failed: (event == current_global_event)
	- imapc: Requesting STATUS for a mailbox with imapc and INDEXPVT
	  configured did not return correct (private) unseen counts.
	- lib-dict: Process would crash when committing data to redis without
	  dict proxy.
	- lib-mail: Corrupted cached BODYSTRUCTURE caused panic during FETCH.
	  Fixes: Panic: file message-part-data.c: line 579 (message_part_is_attachment):
	  assertion failed: (data != NULL). v2.3.13 regression.
	- lib-storage: mail_attribute_dict with dict-sql failed when it tried to
	  lookup empty dict keys.
	- lib: ioloop-kqueue was missing include breaking some BSD builds.
	- lua-http: Dovecot Lua HTTP client could not resolve DNS names in mail
	  processes, because it expected "dns-client" socket to exist in the
	  current directory.
	- oauth2: Using %{oauth2:name} variables could cause useless
	  introspections.
	- pop3: Sending POP3 command with ':' character caused an assert-crash.
	  v2.3.18 regression.
	- replicator: Replication queue had various issues, potentially causing
	  replication requests to become stuck.
	- stats: Invalid Prometheus label names were created with specific
	  histogram group_by configurations. Prometheus rejected these labels.

v2.3.19.1 2022-06-14  Aki Tuomi <aki.tuomi@open-xchange.com>

	- doveadm deduplicate: Non-duplicate mails were deleted.
	  v2.3.19 regression.
	- auth: Crash would occur when iterating multiple backends.
	  Fixes: Panic: file userdb-blocking.c:
	  line 125 (userdb_blocking_iter_next): assertion failed: (ctx->conn != NULL)

v2.3.19 2022-05-10  Aki Tuomi <aki.tuomi@open-xchange.com>

	+ Added mail_user_session_finished event, which is emitted when the mail
	  user session is finished (e.g. imap, pop3, lmtp). It also includes
	  fields with some process statistics information.
	  See https://doc.dovecot.org/admin_manual/list_of_events/ for more
	  information.
	+ Added process_shutdown_filter setting. When an event matches the filter,
	  the process will be shutdown after the current connection(s) have
	  finished. This is intended to reduce memory usage of long-running imap
	  processes that keep a lot of memory allocated instead of freeing it to
	  the OS.
	+ auth: Add cache hit indicator to auth passdb/userdb finished events.
	  See https://doc.dovecot.org/admin_manual/list_of_events/ for more
	  information.
	+ doveadm deduplicate: Performance is improved significantly.
	+ imapc: COPY commands were sent one mail at a time to the remote IMAP
	  server. Now the copying is buffered, so multiple mails can be copied
	  with a single COPY command.
	+ lib-lua: Add a Lua interface to Dovecot's HTTP client library. See
	  https://doc.dovecot.org/admin_manual/lua/ for more information.
	- auth: Cache lookup would use incorrect cache key after username change.
	- auth: Improve handling unexpected LDAP connection errors/hangs.
	  Try to fix up these cases by reconnecting to the LDAP server and
	  aborting LDAP requests earlier.
	- auth: Process crashed if userdb iteration was attempted while auth-workers
	  were already full handling auth requests.
	- auth: db-oauth2: Using %{oauth2:name} variables caused unnecessary
	  introspection requests.
	- dict: Timeouts may have been leaked at deinit.
	- director: Ring may have become unstable if a backend's tag was changed.
	  It could also have caused director process to crash.
	- doveadm kick: Numeric parameter was treated as IP address.
	- doveadm: Proxying can panic when flushing print output. Fixes
	  Panic: file ioloop.c: line 865 (io_loop_destroy): assertion failed:
	  (ioloop == current_ioloop).
	- doveadm sync: BROKENCHAR was wrongly changed to '_' character when
	  migrating mailboxes. This was set by default to %, so any mailbox
	  names containing % characters were modified to "_25".
	- imapc: Copying or moving mails with doveadm to an imapc mailbox could
	  have produced "Error: Syncing mailbox '[...]' failed" Errors. The
	  operation itself succeeded but attempting to sync the destination
	  mailbox failed.
	- imapc: Prevent index log synchronization errors when two or more imapc
	  sessions are adding messages to the same mailbox index files, i.e.
	  INDEX=MEMORY is not used.
	- indexer: Process was slowly leaking memory for each indexing request.
	- lib-fts: fts header filters caused binary content to be sent to the
	  indexer with non-default configuration.
	- doveadm-server: Process could hang in some situations when printing
	  output to TCP client, e.g. when printing doveadm sync state.
	- lib-index: dovecot.index.log files were often read and parsed entirely,
	  rather than only the parts that were actually necessary. This mainly
	  increased CPU usage.
	- lmtp-proxy: Session ID forwarding would cause same session IDs being
	  used when delivering same mail to multiple backends.
	- log: Log prefix update may have been lost if log process was busy.
	  This could have caused log prefixes to be empty or in some cases
	  reused between sessions, i.e. log lines could have been logged for the
	  wrong user/session.
	- mail_crypt: Plugin crashes if it's loaded only for some users. Fixes
	  Panic: Module context mail_crypt_user_module missing.
	- mail_crypt: When LMTP was delivering mails to both recipients with mail
	  encryption enabled and not enabled, the non-encrypted recipients may
	  have gotten mails encrypted anyway. This happened when the first
	  recipient was encrypted (mail_crypt_save_version=2) and the 2nd
	  recipient was not encrypted (mail_crypt_save_version=0).
	- pop3: Session would crash if empty line was sent.
	- stats: HTTP server leaked memory.
	- submission-login: Long credentials, such as OAUTH2 tokens, were refused
	  during SASL interactive due to submission server applying line length
	  limits.
	- submission-login: When proxying to remote host, authentication was not
	  using interactive SASL when logging in using long credentials such as
	  OAUTH2 tokens. This caused authentication to fail due to line length
	  constraints in SMTP protocol.
	- submission: Terminating the client connection with QUIT command after
	  mail transaction is started with MAIL command and before it is
	  finished with DATA/BDAT can cause a segfault crash.
	- virtual: doveadm search queries with mailbox-guid as the only parameter
	  crashes: Panic: file virtual-search.c: line 77 (virtual_search_get_records):
	  assertion failed: (result != 0)

v2.3.18 2022-02-03  Aki Tuomi <aki.tuomi@open-xchange.com>

	* Removed mail_cache_lookup_finished event. This event wasn't especially
	  useful, but it increased CPU usage significantly.
	* fts: Don't index inline base64 encoded content in FTS indexes using
	  the generic tokenizer. This reduces the FTS index sizes by removing
	  input that is very unlikely to be searched for. See
	  https://doc.dovecot.org/configuration_manual/fts/tokenization for
	  details on how base64 is detected. Only applies when using libfts.
	* lmtp: Session IDs are now preserved through proxied connections, so
	  LMTP sessions can be tracked. This slightly changes the LMTP session
	  ID format by appending ":Tn" (transaction), ":Pn" (proxy connection)
	  and ":Rn" (recipient) counters after the session ID prefix.
	+ Events now have "reason_code" field, which can provide a list of
	  reasons why the event is happening. See
	  https://doc.dovecot.org/admin_manual/event_reasons/
	+ New events are added. See https://doc.dovecot.org/admin_manual/list_of_events/
	+ fts: Added fts_header_excludes and fts_header_includes settings to
	  specify which headers to index. See
	  https://doc.dovecot.org/settings/plugin/fts-plugin#plugin-fts-setting-fts-header-excludes
	  for configuration details.
	+ fts: Initialize the textcat language detection library only once per
	  process. This can reduce CPU usage if fts_languages setting has multiple
	  languages listed and service indexer-worker { service_count } isn't 1.
	  Only applies when using libfts.
	+ lib-storage: Reduced CPU usage significantly for some operations that
	  accessed lots of emails (e.g. fetching all flags in a folder, SORT, ...)
	+ lib: DOVECOT_PREREQ() - Add micro version which enables compiling
	  external plugins against different versions of Dovecot.
	+ lmtp: Added new lmtp_verbose_replies setting that makes errors sent to
	  the LMTP client much more verbose with details about why exactly
	  backend proxy connections or commands are failing.
	+ submission: Support implicit SASL EXTERNAL with
	  submission_client_workarounds=implicit-auth-external. This allows
	  automatically logging in when SSL client certificate is present.
	- *-login: Statistics were disabled if stats process connection was lost.
	- auth: Authentication master user login fails with SCRAM-* SASL mechanisms.
	- auth: With auth_cache_verify_password_with_worker=yes, passdb extra
	  fields in the auth cache got lost.
	- doveadm: Fixed crash if zlib_save_level setting was specified,
	  but zlib_save was unset. v2.3.15 regression.
	- doveadm: Proxying can panic when flushing print output. v2.3.17
	  regression. Fixes:
	  Panic: file ioloop.c: line 865 (io_loop_destroy): assertion failed:
	  (ioloop == current_ioloop)
	- doveadm: stats add --group-by parameter didn't work.
	- fts: Using email-address fts tokenizer could result in excessive memory
	  usage with garbage email input. This could cause the indexer-worker
	  processes to fail due to reaching the VSZ memory size limit.
	  Only applies when using libfts.
	- imap: A SEARCH command timing out while fts returns indexes may timeout
	  returning "NO [SERVERBUG]", while it should return "NO [INUSE]" instead.
	- imap: LIST-EXTENDED doesn't return STATUS for all folders. Sending
	  LIST .. RETURN (SUBSCRIBED STATUS (...)) did not return STATUS for
	  folders that are not subscribed when they have a child folder that is
	  subscribed as mandated by IMAP RFCs.
	- imapc: Mailbox vsize calculation crashed with
	  Panic: file index-mailbox-size.c: line 344 (index_mailbox_vsize_hdr_add_missing):
	  assertion failed: (mails_left > 0)
	- indexer: If indexer-worker crashes, the request it was processing gets
	  stuck in the indexer process. This stops indexing for the folder until
	  indexer process is restarted. v2.3.14 regression.
	- indexer: Process was slowly leaking memory for each indexing request.
	- lib-event: Unnamed events were wrongly filtered out for event/metric
	  filters like "event=abc OR something_independent_of_event_name".
	- lib-index: 64-bit big endian CPUs handle last_used field in
	  dovecot.index.cache wrong.
	- lib-ssl-iostream: Fix buggy OpenSSL error handling without assert-crashing.
	  If there is no error available, log it as an error instead of crashing.
	  The previous fix for this in v2.3.11 was incomplete. Fixes
	  Panic: file istream-openssl.c: line 51 (i_stream_ssl_read_real):
	  assertion failed: (errno != 0)
	- lmtp: Out-of-memory issues can happen when proxying large messages to
	  LMTP backend servers that accept the message data too slow.
	- master: HAProxy header parsing has read buffer overflow if provided
	  header size is invalid. This happens only if inet_listener
	  { haproxy=yes } is configured and only if the remote IP address is in
	  haproxy_trusted_networks.
	- old_stats: Plugin kept increasing memory usage, which became
	  noticeable with long-running imap sessions.
	- stats: Dynamically adding same metric multiple times causes multiple stats.
	- submission-login: Authentication does not accept OAUTH2 token (or
	  other very long credentials) because it considers the line to be too long.
	- submission-login: Process can crash if HELO is pipelined with an
	  invalid domain.
	- submission-proxy: Don't use SASL-IR if it would make the AUTH command
	  line longer than 512 bytes.
	- submission: Service would crash if relay server authentication failed.
	- virtual: FTS search in a virtual folder could crash if there are
	  duplicate mailbox GUIDs. This mainly happened when user had both INBOX
	  and INBOX/INBOX folders and the namespace prefix was INBOX/. Fixes
	  Panic: file hash.c: line 252 (hash_table_insert_node):
	  assertion failed: (opcode == HASH_TABLE_OP_UPDATE)
	- virtual: If mailbox opening fails, the backend mailbox is leaked and
	  process crashes when client disconnects. Fixes
	  Panic: file mail-user.c: line 232 (mail_user_deinit):
	  assertion failed: ((*user)->refcount == 1)
	- virtual: Searching headers in virtual folders didn't always use
	  full-text search indexes, if fts_enforced=no or body.

v2.3.17.1 2021-12-07  Aki Tuomi <aki.tuomi@open-xchange.com>

	- dsync: Add back accidentically removed parameters.
	- lib-ssl-iostream: Fix assert-crash when OpenSSL returned syscall error
	  without errno.
	- master: Dovecot failed to start if ssl_ca was too large.

v2.3.17 2021-10-28  Aki Tuomi <aki.tuomi@open-xchange.com>

	* Dovecot now logs a warning if time seems to jump forward at least
	  100 milliseconds.
	* dict: Lines logged by the dict process now contain the dict name as
	  the prefix.
	* lib-index: mail_cache_fields, mail_always_cache_fields and
	  mail_never_cache_fields now verifies that the listed header names are
	  valid. Especially the UTF8 "–" character has sometimes been wrongly
	  used instead of the ASCII "-".
	+ *-login: Added login_proxy_rawlog_dir setting to capture
	  rawlogs between proxy and backend.
	+ dict: The server process now keeps the last 10 idle dict backends
	  cached for maximum of 30 seconds. Practically this acts as a
	  connection pool for dict-redis and dict-ldap. Note that this doesn't
	  affect dict-sql, because it already had its own internal cache.
	+ doveadm: New stats add/remove commands added to support changing the
	  metrics configuration on runtime.
	+ lazy_expunge: Added lazy_expunge_exclude settings to disable
	  lazy_expunge for specific folders. \Special-use flags can be used as
	  folder names.
	+ lib-lua: Added a new helper function dovecot.restrict_global_variables()
	  to disable or enable defining new global variables.
[--snip--]
